/*      .

	 ,    (
	    ).   
	         "".
*/


#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\scroller.h>
#include <stdio.h>
#include <owl\dc.h>
#include <owl\choosefo.h>
#include <owl\opensave.h>
#include <string.h>
#include "tz.rc"

// 
class TApp: public TApplication
{
  public:
	 TApp():TApplication(){}
	 void InitMainWindow();
};

//  
class TWndw : public TFrameWindow
{
  public:
	 TWndw(TWindow *parent, const char far *title);
         ~TWndw();
  protected:
         TFont *font;
			TColor fontColor;
			char filen [255];
			//     
			int fheight;
			void CmChooseFont();
			void CmFileOpen();
			void  Paint (TDC &paintDC, BOOL, TRect&);

	 DECLARE_RESPONSE_TABLE (TWndw);
};

DEFINE_RESPONSE_TABLE1 (TWndw, TFrameWindow)
  EV_COMMAND(CM_CHOOSEFONT, CmChooseFont),
  EV_COMMAND(CM_FILEOPEN, CmFileOpen),
END_RESPONSE_TABLE;

TWndw::TWndw(TWindow *parent, const char far *title):
		  TFrameWindow(parent,title)
{
	//      
	Attr.Style |= WS_VSCROLL;
	Scroller = new TScroller (this, 1, 1, 640, 480);
	//     .
	AssignMenu("MENU_1");
	//     .
	Attr.W=GetSystemMetrics(SM_CXSCREEN);
	Attr.H=GetSystemMetrics(SM_CXSCREEN)-1000;
	//   ,   .
	font = 0;
	fontColor = TColor::Black;
	strcpy(filen,"");
	fheight =-15;
}

// TWndw::~TWndw()
//    .
TWndw::~TWndw()
{
  //    ,  .
  if (font) delete font;
}

// TWndw::CmChooseFont()
//      Choose Font,
//    "".
void TWndw::CmChooseFont()
{
  //      .
  char errorMsg[81];
  //   TData   Font.
  TChooseFontDialog::TData fontData;
  //   TData. 
  fontData.Flags = CF_EFFECTS | CF_TTONLY | 
     CF_FORCEFONTEXIST | CF_SCREENFONTS;
  fontData.Color = fontColor;
  //    Font.
  TChooseFontDialog *dialog =
       new TChooseFontDialog (this, fontData);
  //    Font. 
  int result = dialog->Execute();
  //    "OK"  .
  if (result == IDOK)
  {
      //   ,   .
      if (font) delete font;
      //      . 
      font = new TFont(&fontData.LogFont);
		//    .
		fontColor = fontData.Color;
		fheight = fontData.LogFont.lfHeight;
      //   . 
		Invalidate();
  }
  //   ... 
  else if (fontData.Error != 0) 
         {
           //     . 
           wsprintf(errorMsg," #%ld.", fontData.Error); 
           MessageBox(errorMsg, "",  MB_OK | MB_ICONEXCLAMATION);
         }
}


// TWndw::CmFileOpent()
//      Open,
//    " ".
void TWndw::CmFileOpen()
{
  char errorMsg[81];
  //   TData  . 
  TOpenSaveDialog::TData fileData (OFN_FILEMUSTEXIST | OFN_HIDEREADONLY
      | OFN_PATHMUSTEXIST, 
     "  (*.*)|*.*|  (*.txt)|*.txt|", 0, 0, "*");
  //    Open. 
  TFileOpenDialog *dialog = new TFileOpenDialog(this, fileData);
  //    Open. 
  int result = dialog->Execute();
  //    "OK"  . 
  if (result == IDOK) {
		 strcpy(filen,fileData.FileName);
  }
  else if (fileData.Error != 0)
       {
			wsprintf(errorMsg,"  #%ld.", fileData.Error);
			MessageBox(errorMsg, "",  MB_OK | MB_ICONEXCLAMATION);
		 }
  Invalidate();
}

//TWndw::Paint()
//     Paint()  
// TWindow     WM_PAINT,  
// Windows  ,     
//  .
void TWndw::Paint(TDC &paintDC, BOOL, TRect&)
{
  //    ...
  if (font)
        // ...     .
        paintDC.SelectObject (*font); 
  //   .
  paintDC.SetTextColor (fontColor);  
  //     .
  //MessageBox(filen, "",  MB_OK | MB_ICONEXCLAMATION);
  int tm=1;
  if (strcmp(filen,"")==0) { paintDC.TextOut(10, 10, " "); }
	 else {
	FILE *ReadF;
	ReadF=fopen(filen, "r");
		  char  rline[300];
		  do{
			 fgets(rline,300,ReadF);
		  if (feof(ReadF)) break;
		  if (rline[strlen(rline)-1]== '\n') rline[strlen(rline)-1]=0;
		  paintDC.TextOut(10, 10-fheight*tm, rline);
		  tm++;
		  }while(true);
		  fclose(ReadF);
  }
//    
Scroller->SetRange(0, (-1)*fheight*tm);

}

void TApp::InitMainWindow()
{
  TFrameWindow *wndw= new TWndw(0,"-");
  SetMainWindow(wndw);
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
